diff --git a/target-arm/op_helper.c b/target-arm/op_helper.c
index 6e14a4d..a9bd95b 100644
--- a/target-arm/op_helper.c
+++ b/target-arm/op_helper.c
@@ -1,7 +1,7 @@
 /*
  *  ARM helper routines
  *
- *  Copyright (c) 2005 CodeSourcery, LLC
+ *  Copyright (c) 2005-2007 CodeSourcery, LLC
  *
  * This library is free software; you can redistribute it and/or
  * modify it under the terms of the GNU Lesser General Public
@@ -175,6 +175,81 @@ void do_vfp_get_fpscr(void)
     T0 |= vfp_exceptbits_from_host(i);
 }
 
+float32 helper_recps_f32(float32 a, float32 b)
+{
+    float_status *s = &env->vfp.fp_status;
+    float32 two = int32_to_float32(2, s);
+    return float32_sub(two, float32_mul(a, b, s), s);
+}
+
+float32 helper_rsqrts_f32(float32 a, float32 b)
+{
+    float_status *s = &env->vfp.fp_status;
+    float32 three = int32_to_float32(3, s);
+    return float32_sub(three, float32_mul(a, b, s), s);
+}
+
+/* TODO: The architecture specifies the value that the estimate functions
+   should return.  We return the exact reciprocal/root instead.  */
+float32 helper_recpe_f32(float32 a)
+{
+    float_status *s = &env->vfp.fp_status;
+    float32 one = int32_to_float32(1, s);
+    return float32_div(one, a, s);
+}
+
+float32 helper_rsqrte_f32(float32 a)
+{
+    float_status *s = &env->vfp.fp_status;
+    float32 one = int32_to_float32(1, s);
+    return float32_div(one, float32_sqrt(a, s), s);
+}
+
+uint32_t helper_recpe_u32(uint32_t a)
+{
+    float_status *s = &env->vfp.fp_status;
+    float32 tmp;
+    tmp = int32_to_float32(a, s);
+    tmp = float32_scalbn(tmp, -32, s);
+    tmp = helper_recpe_f32(tmp);
+    tmp = float32_scalbn(tmp, 31, s);
+    return float32_to_int32(tmp, s);
+}
+
+uint32_t helper_rsqrte_u32(uint32_t a)
+{
+    float_status *s = &env->vfp.fp_status;
+    float32 tmp;
+    tmp = int32_to_float32(a, s);
+    tmp = float32_scalbn(tmp, -32, s);
+    tmp = helper_rsqrte_f32(tmp);
+    tmp = float32_scalbn(tmp, 31, s);
+    return float32_to_int32(tmp, s);
+}
+
+void helper_neon_tbl(int rn, int maxindex)
+{
+    uint32_t val;
+    uint32_t mask;
+    uint32_t tmp;
+    int index;
+    int shift;
+    uint64_t *table;
+    table = (uint64_t *)&env->vfp.regs[rn];
+    val = 0;
+    mask = 0;
+    for (shift = 0; shift < 32; shift += 8) {
+        index = (T1 >> shift) & 0xff;
+        if (index <= maxindex) {
+            tmp = (table[index >> 3] >> (index & 7)) & 0xff;
+            val |= tmp << shift;
+        } else {
+            val |= T0 & (0xff << shift);
+        }
+    }
+    T0 = val;
+}
+
 #if !defined(CONFIG_USER_ONLY)
 
 #define MMUSUFFIX _mmu
@@ -227,5 +302,4 @@ void tlb_fill (target_ulong addr, int is_write, int mmu_idx, void *retaddr)
     }
     env = saved_env;
 }
-
 #endif
diff --git a/target-arm/op_mem.h b/target-arm/op_mem.h
index 6bccb06..b12b63c 100644
--- a/target-arm/op_mem.h
+++ b/target-arm/op_mem.h
@@ -1,5 +1,6 @@
 /* ARM memory operations.  */
 
+void helper_ld(uint32_t);
 /* Load from address T1 into T0.  */
 #define MEM_LD_OP(name) \
 void OPPROTO glue(op_ld##name,MEMSUFFIX)(void) \
@@ -49,6 +50,64 @@ MEM_SWP_OP(l, l)
 
 #undef MEM_SWP_OP
 
+/* Load-locked, store exclusive.  */
+#define EXCLUSIVE_OP(suffix, ldsuffix) \
+void OPPROTO glue(op_ld##suffix##ex,MEMSUFFIX)(void) \
+{ \
+    cpu_lock(); \
+    helper_mark_exclusive(env, T1); \
+    T0 = glue(ld##ldsuffix,MEMSUFFIX)(T1); \
+    cpu_unlock(); \
+    FORCE_RET(); \
+} \
+ \
+void OPPROTO glue(op_st##suffix##ex,MEMSUFFIX)(void) \
+{ \
+    int failed; \
+    cpu_lock(); \
+    failed = helper_test_exclusive(env, T1); \
+    /* ??? Is it safe to hold the cpu lock over a store?  */ \
+    if (!failed) { \
+        glue(st##suffix,MEMSUFFIX)(T1, T0); \
+    } \
+    T0 = failed; \
+    cpu_unlock(); \
+    FORCE_RET(); \
+}
+
+EXCLUSIVE_OP(b, ub)
+EXCLUSIVE_OP(w, uw)
+EXCLUSIVE_OP(l, l)
+
+#undef EXCLUSIVE_OP
+
+/* Load exclusive T0:T1 from address T1.  */
+void OPPROTO glue(op_ldqex,MEMSUFFIX)(void)
+{
+    cpu_lock();
+    helper_mark_exclusive(env, T1);
+    T0 = glue(ldl,MEMSUFFIX)(T1);
+    T1 = glue(ldl,MEMSUFFIX)((T1 + 4));
+    cpu_unlock();
+    FORCE_RET();
+}
+
+/* Store exclusive T0:T2 to address T1.  */
+void OPPROTO glue(op_stqex,MEMSUFFIX)(void)
+{
+    int failed;
+    cpu_lock();
+    failed = helper_test_exclusive(env, T1);
+    /* ??? Is it safe to hold the cpu lock over a store?  */
+    if (!failed) {
+        glue(stl,MEMSUFFIX)(T1, T0);
+        glue(stl,MEMSUFFIX)((T1 + 4), T2);
+    }
+    T0 = failed;
+    cpu_unlock();
+    FORCE_RET();
+}
+
 /* Floating point load/store.  Address is in T1 */
 #define VFP_MEM_OP(p, w) \
 void OPPROTO glue(op_vfp_ld##p,MEMSUFFIX)(void) \
